"use strict";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Copyright (c) 2020-present Ruben Arushanyan (https://github.com/ruben-arushanyan)
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 * 
 */
var _require = require('./utils'),
    isSymbol = _require.isSymbol;

var _require2 = require('./normalizeHandler'),
    normalizeHandler = _require2.normalizeHandler;

var getProxyTarget = function getProxyTarget(handler, path) {
  var _Object$definePropert;

  var call = handler.call,
      toPrimitive = handler.toPrimitive;

  var target = function target() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return call(path, args);
  };

  Object.defineProperties(target, (_Object$definePropert = {}, _defineProperty(_Object$definePropert, Symbol.toPrimitive, {
    value: function value(hint) {
      return toPrimitive(path, hint);
    },
    enumerable: false
  }), _defineProperty(_Object$definePropert, "toString", {
    value: function value() {
      return target[Symbol.toPrimitive]('string');
    },
    enumerable: false
  }), _defineProperty(_Object$definePropert, "valueOf", {
    value: function value() {
      return target[Symbol.toPrimitive]('number');
    },
    enumerable: false
  }), _Object$definePropert));
  return Object.freeze(target);
};

var createProducer = function createProducer(handler, path) {
  var target = getProxyTarget(handler, path);
  return new Proxy(target, {
    get: function get(target, prop) {
      if (isSymbol(prop) || ['toString', 'valueOf'].includes(prop)) {
        return target[prop];
      }

      return createProducer(handler, [].concat(_toConsumableArray(path), [prop]));
    }
  });
};

function ProduceByPath(handler) {
  handler = normalizeHandler(handler);
  return createProducer(handler, []);
}

module.exports = ProduceByPath;